/*
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * File created by null on 7/5/09.
 */

#import <Cocoa/Cocoa.h>

extern NSString *HCCShouldShowRestartingHaloServerWarning;
extern NSString *HCCShouldMakeHostSpectatorWarning;
extern NSString *HCCClientDisconnectNotification;

@interface HCCController : NSObject
{
	// connecting window
	IBOutlet NSComboBox				*serverAddressComboBox;
	IBOutlet NSTextField			*passwordTextField;
	IBOutlet NSWindow				*connectToServerWindow;
	IBOutlet NSButton				*connectButton;
	IBOutlet NSProgressIndicator	*connectToServerProgressIndicator;
	
	// connection history
	NSArray							*serverAddressesHistoryArray;
	NSArray							*serverPasswordsHistoryArray;
	
	// client changing window
	IBOutlet NSWindow				*mainWindow;
	IBOutlet NSTextField			*haloServerNameTextField;
	IBOutlet NSTextField			*haloPasswordTextField;
	IBOutlet NSTextField			*haloMaxPlayersTextField;
	IBOutlet NSButton				*applyButton;
	IBOutlet NSButton				*restoreButton;
	IBOutlet NSStepper				*haloMaxPlayersStepper;
	
	// restarting halo server stuff
	IBOutlet NSWindow				*restartingHaloDemoServerWindow;
	IBOutlet NSProgressIndicator	*restartingHaloDemoProgressIndicator;
	NSModalSession					restartingHaloDemoServerSession;
	
	// spectator stuff
	IBOutlet NSMenuItem				*makeHostASpectatorMenuItem;
	
	int								socketDescriptor;
	fd_set							masterSet;
	BOOL							clientIsConnected;
}

- (IBAction)showConnectToServerWindow:(id)sender;
- (IBAction)showMainWindow:(id)sender;
- (IBAction)connectToServer:(id)sender;
- (IBAction)restoreChanges:(id)sender;
- (IBAction)applyChanges:(id)sender;
- (IBAction)restartHaloDemoServer:(id)sender;
- (IBAction)makeHostASpectator:(id)sender;
- (IBAction)cancelRestartingHaloDemoServer:(id)sender;
- (IBAction)haloMaxPlayersStepper:(id)sender;

@end
