/*
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * File created by null on 4/12/09.
 */

#import <Cocoa/Cocoa.h>
@class ThreadedTask;
@class HSCPreferencesController;

extern NSString *HSCServerNameAddressKey;
extern NSString *HSCServerShutOffNotification;
extern NSString	*HSCServerFailedToStartNotification;
extern NSString *HSCShouldShowRestartingHaloServerWarning;
extern NSString *HSCShouldCacheRestartingHaloServerAddresses;
extern NSString *HSCShouldMakeHostSpectatorWarning;

@interface HSCController : NSObject
{	
	IBOutlet NSButton *applyButton;
	IBOutlet NSButton *restoreButton;
	IBOutlet NSTextField *serverNameTextField;
	IBOutlet NSTextField *passwordTextField;
	IBOutlet NSTextField *maxPlayersTextField;
	IBOutlet NSStepper *maxPlayersStepper;
	
	IBOutlet NSWindow *setupWindow;
	IBOutlet NSWindow *mainWindow;
	IBOutlet NSButton *syncButton;
	IBOutlet NSProgressIndicator *syncProgressIndicator;
	
	int _serverNameAddress;
	int _passwordAddress;
	int _maxPlayersAddress;
	
	NSTimer *readServerInfoTimer;
	
	int haloProcessID;
	
	ThreadedTask *syncingTask;
	
	ThreadedTask *restartingHaloDemoTask;
	IBOutlet NSWindow *restartingHaloServerWindow;
	IBOutlet NSProgressIndicator *restartingHaloServerProgressIndicator;
	NSModalSession restartingHaloServerSession;
	int interestedClientSocket;
	BOOL restartingHaloDemoTaskShouldCancel;
	
	BOOL serverIsUp;
	BOOL remoteAccessServerIsUp;
	int maxSocket;
	int listenerSocket;
	fd_set masterSet;
	
	NSTimer *makeHostASpectatorTimer;
	IBOutlet NSMenuItem *makeHostASpectatorMenuItem;
	BOOL hostIsGoingToSpectateFromThreadNotice;
	
	HSCPreferencesController *preferencesController;
}

+ (HSCController *)sharedController;

- (IBAction)applyChanges:(id)sender;
- (IBAction)maxPlayersStepper:(id)sender;
- (IBAction)restoreServerInfo:(id)sender;
- (IBAction)showResynchronizationWindow:(id)sender;
- (IBAction)removeHaloGameRestartCache:(id)sender;
- (IBAction)restartHaloDemoServer:(id)sender;
- (IBAction)cancelRestartingHaloDemoServer:(id)sender;
- (IBAction)makeHostASpectator:(id)sender;

- (IBAction)syncToHaloDemo:(id)sender;

- (void)enableRemoteAccess:(BOOL)remoteAccessState;

- (IBAction)openPreferences:(id)sender;
- (IBAction)openMainWindow:(id)sender;

@end
