/*
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * File created by null on 7/5/09.
 */

#import <Cocoa/Cocoa.h>

extern NSString *HSCListeningPort;
extern NSString *HSCServerPassword;
extern NSString *HSCEnableRemoteAccess;

@interface HSCPreferencesController : NSObject
{
	IBOutlet NSWindow				*window;
	IBOutlet NSTextField			*serverPasswordTextField;
	IBOutlet NSTextField			*listeningPortTextField;
	IBOutlet NSButton				*enableRemoteAccessButton;
	IBOutlet NSTextField			*serverPasswordTextFieldLabel;
	IBOutlet NSTextField			*listeningPortTextFieldLabel;
	
	IBOutlet NSProgressIndicator	*applyingChangesProgressIndicator;
	IBOutlet NSButton				*applyChangesButton;
	BOOL							serverIsRestarting;
}

- (void)showWindow;

- (IBAction)enableRemoteAccess:(id)sender;
- (IBAction)applyChanges:(id)sender;
- (void)turnOffServer;

@end
